/* eslint valid-jsdoc: "off" */

'use strict';

/**
 * @param {Egg.EggAppInfo} appInfo app info
 */
module.exports = appInfo => {
  /**
   * built-in config
   * @type {Egg.EggAppConfig}
   **/
  const config = exports = {};

  // use for cookie sign key, should change to your own and keep security
  config.keys = appInfo.name + '_1562143426996_4997';

  // add your middleware config here
  config.middleware = [];

  // add your user config here
  const userConfig = {
    // myAppName: 'egg',
  };
  config.static = {
    prefix: null,
  };
  config.auth = {
    enable : false,
    expire:3000,
    whiteList : authWhiteList
  };
 config.development = {
  watchDirs : ['api']
 }
  config.security = {
    csrf: {
      enable: false,
      ignoreJSON: true
    }
  };
  config.jwt = {
    enable:false,
    secret: '123456',
    whiteList : jwtWhiteList
  };
  config.cluster = {
    listen: {
      port: 33000,
    }
  }
  config.customLogger = {
    scheduleLogger : {
      level: 'DEBUG',
      consoleLevel: 'DEBUG',
    }
  }
  config.logger = {
    level: 'DEBUG',
    consoleLevel: 'DEBUG',
  };
  config.cors = {
    origin:'*',
    allowMethods: 'GET,HEAD,PUT,POST,DELETE,PATCH,OPTIONS'
  };
  config.mysql = {
    clients:{
      db1: {
         // host
      host: '',
      // 端口号
      port: '',
      // 用户名
      user: '',
      acquireTimeout: 60*60*1000,
      // 密码
      password: '',
        // 数据库名默认
      database: ''
      },
    }
  };
  config.httpclient = {
    request: {
      timeout: 10000*1000,
    },
  }
  return {
    ...config,
    ...userConfig,
  };
};
let authWhiteList = [

]
let jwtWhiteList = [
    
]